package edu.ucf.rp2;

import java.util.LinkedList;
import java.util.List;

import difflib.DiffUtils;
import difflib.Patch;

public class DiffLines {
	
	
	public static double perecentDiff (String document1, String document2)
	{
        List<String> file1_list = stringToLines(document1);
        List<String> file2_list = stringToLines(document2);
		
        Patch patch = DiffUtils.diff(file1_list, file2_list);
        int numDeltas = patch.getDeltas().size();
        int numLines = Math.max(file1_list.size(), file2_list.size());
        
        return (double)100 * numDeltas / numLines;
	}
	
	
    private static List<String> stringToLines (String input)
    {
    	List<String> lines = new LinkedList<String>();
    	
    	String[] line = input.split("\n");
    	for (int i=0; i<line.length; i++)
    		lines.add(line[i]);
    	
    	return lines;
    }
    
    
}
