package edu.ucf.rp2;

import java.util.ArrayList;
import java.util.List;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

public abstract class SERP {

	
	protected String adKeyWord;
	protected String serpUrl;
	protected String serpSource;
	
	
	public SERP (String phrase, 
			     String serpUrlPrefix, 
			     String adKeyWord) 
	{
		this.adKeyWord = adKeyWord;
		serpUrl = serpUrlPrefix + phrase.replaceAll(" ", "+");
		
		fetchSearchSource();
	}
	
	
	protected void fetchSearchSource () {
		WebFetcher wb = new WebFetcher(serpUrl);
		wb.exec();
		serpSource = wb.getSource();
	}
	
	
	public List<GoogleAd> ads () {
		List<GoogleAd> adURLList = new ArrayList<GoogleAd>();
		Elements adElements = extractAdElements(serpSource);
		
		for (Element adElement : adElements)
		{
			String adURL = adElement.attr("href");
			GoogleAd ad = new GoogleAd(adURL);
			adURLList.add(ad);
		}
		
		return adURLList;
	}
	
	
	protected Elements extractAdElements (String serpSource) {
		Elements adElements = new Elements();
		
		Document document = Jsoup.parse(serpSource);
		Elements anchors = document.getElementsByTag("a");
		for (Element anchor : anchors)
		{
			if (anchor.attr("href").indexOf(adKeyWord)!=-1) {
				adElements.add(anchor);
			}
		}
		
		return adElements;
	}	
	
	
	public String getSERPSource () {
		return serpSource;
	}
	
}
